/* SPDX-License-Identifier: GPL-2.0-or-later */
/*
 * Register header for ST ST25R SPI NFC Chip
 *
 * Copyright (C) 2020 Olliver Schinagl <oliver@schinagl.nl>
 * Copyright (C) 2020 ONPLICK, Paweł Żabiełowicz <pzabielowicz@onplick.com>
 */

#ifndef __ST25R39_REG_H_
#define __ST25R39_REG_H_ __FILE__

#define ST25R39_MODE_MASK			GENMASK(7, 6)
#define ST25R39_MODE_OFFSET			6
#define ST25R39_CMD_MASK			GENMASK(5, 0)

#define _ST25R39_MODE_WRITE				0b00
#define _ST25R39_MODE_READ				0b01
#define _ST25R39_MODE_FIFO				0b10
#define _ST25R39_MODE_DIRECT_COMMAND			0b11

#define _ST25R39_CMD_FIFO_LOAD				0b000000
#define _ST25R39_CMD_FIFO_READ				0b111111

#define ST25R39_MODE_WRITE(reg) \
	((_ST25R39_MODE_WRITE << ST25R39_MODE_OFFSET) | ((reg) & ST25R39_CMD_MASK))
#define ST25R39_MODE_READ(reg) \
	((_ST25R39_MODE_READ << ST25R39_MODE_OFFSET) | ((reg) & ST25R39_CMD_MASK))
#define ST25R39_MODE_FIFO_LOAD \
	((_ST25R39_MODE_FIFO << ST25R39_MODE_OFFSET) | _ST25R39_CMD_FIFO_LOAD)
#define ST25R39_MODE_FIFO_READ \
	((_ST25R39_MODE_FIFO << ST25R39_MODE_OFFSET) | _ST25R39_CMD_FIFO_READ)

#define ST25R39_IO_CONF1			0x00
#define ST25R39_IO_CONF1_DEFAULT_SETTINGS	0x08
#define ST25R39_IO_CONF1_SINGLE				BIT(7)
#define ST25R39_IO_CONF1_RFO2				BIT(6)
#define ST25R39_IO_CONF1_FIFO_LR			BIT(5)
#define ST25R39_IO_CONF1_FIFO_LR_GET(reg) \
	((reg) ? 80 : 64)
#define ST25R39_IO_CONF1_FIFO_LR_SET(level) \
	(((level) > 64) ? ST25R39_IO_CONF1_FIFO_LR : 0)
#define ST25R39_IO_CONF1_FIFO_LT			BIT(4)
#define ST25R39_IO_CONF1_FIFO_LT_GET(reg) \
	((reg) ? 16 : 32)
#define ST25R39_IO_CONF1_FIFO_LT_SET(level) \
	(((level) > 16) ? 0 : ST25R39_IO_CONF1_FIFO_LT)
#define ST25R39_IO_CONF1_OSC				BIT(3)
#define ST25R39_IO_CONF1_OUT_CL_MASK			GENMASK(2, 1)
#define ST25R39_IO_CONF1_OUT_CL_OFFSET			1
#define ST25R39_IO_CONF1_OUT_CL_DISABLE			0x03
#define ST25R39_IO_CONF1_OUT_CL_13MHz			0x02
#define ST25R39_IO_CONF1_OUT_CL_6MHz			0x01
#define ST25R39_IO_CONF1_OUT_CL_3MHz			0x00
#define ST25R39_IO_CONF1_OUT_CL_GET(freq) \
	(((freq) & ST25R39_IO_CONF1_OUT_CL_MASK) >> ST25R39_IO_CONF1_OUT_CL_OFFSET)
#define ST25R39_IO_CONF1_OUT_CL_SET(freq) \
	(((freq) << ST25R39_IO_CONF1_OUT_CL_OFFSET) & ST25R39_IO_CONF1_OUT_CL_MASK)
#define ST25R39_IO_CONF1_LF_CLK_OFF			BIT(0)

#define ST25R39_IO_CONF2			0x01
#define ST25R39_IO_CONF2_SUP3V				BIT(7)
#define ST25R39_IO_CONF2_SUP3V_INPUT_VOLTAGE_MAX	3600
#define ST25R39_IO_CONF2_VSPD_OFF			BIT(6)
/* Not used		 				BIT(5) */
#define ST25R39_IO_CONF2_MISO_PD2			BIT(4)
#define ST25R39_IO_CONF2_MISO_PD1			BIT(3)
#define ST25R39_IO_CONF2_IO18				BIT(2)
/* Not used						BIT(1) */
#define ST25R39_IO_CONF2_SLOW_UP			BIT(0)

#define ST25R39_OPERATION_CTL			0x02
#define ST25R39_OPERATION_CTL_EN			BIT(7)
#define ST25R39_OPERATION_CTL_RX_EN			BIT(6)
#define ST25R39_OPERATION_CTL_RX_CHN			BIT(5)
#define ST25R39_OPERATION_CTL_RX_MAN			BIT(4)
#define ST25R39_OPERATION_CTL_TX_EN			BIT(3)
#define ST25R39_OPERATION_CTL_WU			BIT(2)
/* Not used						BIT(1) */
/* Not used						BIT(0) */

#define ST25R39_MODE_DEF			0x03
#define ST25R39_MODE_DEF_TARGET				BIT(7)
#define ST25R39_MODE_DEF_OM_MASK			GENMASK(6, 3)
#define ST25R39_MODE_DEF_OM_OFFSET			3
#define ST25R39_MODE_DEF_OM_BPSK			0xf
#define ST25R39_MODE_DEF_OM_SUB_CARRIER_STREAM_MODE	0xe
/* 0x5 - 0xd not used */
#define ST25R39_MODE_DEF_OM_IN_TOPAZ			0x4
#define ST25R39_MODE_DEF_OM_IN_FELICA			0x3
#define ST25R39_MODE_DEF_OM_IN_ISO1443B			0x2
#define ST25R39_MODE_DEF_OM_IN_ISO1443A			0x1
#define ST25R39_MODE_DEF_OM_IN_NFCIP1_ACTIVE		0x0
/* 0x2 - 0xf not used */
#define ST25R39_MODE_DEF_OM_TG_NFCIP1_ACTIVE_NORMAL	0x1
#define ST25R39_MODE_DEF_OM_TG_NFCIP1_ACTIVE_BRD	0x0
#define ST25R39_MODE_DEF_OM_GET(mode) \
	(((mode) & ST25R39_MODE_DEF_OM_MASK) >> ST25R39_MODE_DEF_OM_OFFSET)
#define ST25R39_MODE_DEF_OM_SET(mode) \
	(((mode) << ST25R39_MODE_DEF_OM_OFFSET) & ST25R39_MODE_DEF_OM_MASK)
/* Not used						BIT(2) */
/* Not used						BIT(1) */
#define ST25R39_MODE_DEF_NFC_AR				BIT(0)

#define ST25R39_BIT_RATE_DEF			0x04
#define ST25R39_BIT_RATE_DEF_TX_RATE_MASK		GENMASK(7, 4)
#define ST25R39_BIT_RATE_DEF_TX_RATE_OFFSET		4
#define ST25R39_BIT_RATE_DEF_RX_RATE_MASK		GENMASK(3, 0)
#define ST25R39_BIT_RATE_DEF_RX_RATE_OFFSET		0
#define ST25R39_BIT_RATE_DEF_RATE_848KPBS		0x03
#define ST25R39_BIT_RATE_DEF_RATE_424KBPS		0x02
#define ST25R39_BIT_RATE_DEF_RATE_212KBPS		0x01
#define ST25R39_BIT_RATE_DEF_RATE_106KBPS		0x00
#define ST25R39_BIT_RATE_DEF_TX_RATE_GET(rate) \
	(((rate) & ST25R39_BIT_RATE_DEF_TX_RATE_MASK) >> ST25R39_BIT_RATE_DEF_TX_RATE_OFFSET)
#define ST25R39_BIT_RATE_DEF_TX_RATE_SET(rate) \
	(((rate) << ST25R39_BIT_RATE_DEF_TX_RATE_OFFSET) & ST25R39_BIT_RATE_DEF_TX_RATE_MASK)
#define ST25R39_BIT_RATE_DEF_RX_RATE_GET(rate) \
	(((rate) & ST25R39_BIT_RATE_DEF_RX_RATE_MASK) >> ST25R39_BIT_RATE_DEF_RX_RATE_OFFSET)
#define ST25R39_BIT_RATE_DEF_RX_RATE_SET(rate) \
	(((rate) << ST25R39_BIT_RATE_DEF_RX_RATE_OFFSET) & ST25R39_BIT_RATE_DEF_RX_RATE_MASK)

#define ST25R39_ISO1443A_NFC106			0x05
#define ST25R39_ISO1443A_NFC106_NO_TX_PAR		BIT(7)
#define ST25R39_ISO1443A_NFC106_NO_RX_PAR		BIT(6)
#define ST25R39_ISO1443A_NFC106_NFC_F0			BIT(5)
#define ST25R39_ISO1443A_NFC106_P_LEN_MASK		GENMASK(4, 1)
#define ST25R39_ISO1443A_NFC106_P_LEN_OFFSET		1
#define ST25R39_ISO14443A_PWM_FC16_GET(reg) \
	(((reg) & 0b1000) ? (reg) + 5 : (reg) + 2)
#define ST25R39_ISO14443A_PWM_FC16_SET(periods) \
	(((periods) > 5) ? (periods) - 5 : (periods) - 5 + 0b1000)
#define ST25R39_ISO14443A_PWM_FC32_GET(reg) \
	(((reg) & 0b1000) ? (reg) + 5 : (reg) + 9)
#define ST25R39_ISO14443A_PWM_FC32_SET(periods) \
	(((periods) > 9) ? (periods) - 9 : (periods) - 9 + 0b1000)
#define ST25R39_ISO14443A_PWM_FC64_GET(reg) \
	(((reg) & 0b1000) ? (reg) + 12 : (reg) + 18)
#define ST25R39_ISO14443A_PWM_FC64_SET(periods) \
	(((periods) > 18) ? (periods) - 18 : (periods) - 18 + 0b1000)
#define ST25R39_ISO14443A_PWM_FC128_GET(reg) \
	(((reg) & 0b1000) ? (reg) + 27 : (reg) + 35)
#define ST25R39_ISO14443A_PWM_FC128_SET(periods) \
	(((periods) > 35) ? (periods) - 35 : (periods) - 35 + 0b1000)
#define ST25R39_ISO1443A_NFC106_P_LEN_GET(pwm) \
	(((pwm) & ST25R39_ISO1443A_NFC106_P_LEN_MASK) >> ST25R39_ISO1443A_NFC106_P_LEN_OFFSET)
#define ST25R39_ISO1443A_NFC106_P_LEN_SET(pwm) \
	(((pwm) << ST25R39_ISO1443A_NFC106_P_LEN_OFFSET) & ST25R39_ISO1443A_NFC106_P_LEN_MASK)

#define ST25R39_ISO1443A_NFC106_ANTCL			BIT(0)

#define ST25R39_ISO1443B			0x06
#define ST25R39_ISO1443B_EGT_MASK			GENMASK(7, 5)
#define ST25R39_ISO1443B_EGT_OFFSET			5
#define ST25R39_ISO1443B_EGT_GET(etu) \
	(((etu) & ST25R39_ISO1443B_EGT_MASK) >> ST25R39_ISO1443B_EGT_OFFSET)
#define ST25R39_ISO1443B_EGT_SET(etu) \
	(((etu) << ST25R39_ISO1443B_EGT_OFFSET) & ST25R39_ISO1443B_EGT_MASK)
#define ST25R39_ISO1443B_SOF_0				BIT(4)
#define ST25R39_ISO1443B_SOF_1				BIT(3)
#define ST25R39_ISO1443B_EOF				BIT(2)
#define ST25R39_ISO1443B_HALF				BIT(1)
#define ST25R39_ISO1443B_RX_ST_OM			BIT(0)

#define ST25R39_ISO1443B_FELICA			0x07
#define ST25R39_ISO1443B_FELICA_TR1_MASK		GENMASK(7, 6)
#define ST25R39_ISO1443B_FELICA_TR1_OFFSET		6
#define ST25R39_ISO1443B_FELICA_TR1_FC_32FS		0x1
#define ST25R39_ISO1443B_FELICA_TR1_FC_80FS		0x0
#define ST25R39_ISO1443B_FELICA_TR1_FC128_64FS		0x1
#define ST25R39_ISO1443B_FELICA_TR1_FC128_80FS		0x0
#define ST25R39_ISO1443B_FELICA_TR1_GET(tr1) \
	(((tr1) & ST25R39_ISO1443B_FELICA_TR1_MASK) >> ST25R39_ISO1443B_FELICA_TR1_OFFSET)
#define ST25R39_ISO1443B_FELICA_TR1_SET(tr1) \
	(((tr1) << ST25R39_ISO1443B_FELICA_TR1_OFFSET) & ST25R39_ISO1443B_FELICA_TR1_MASK)
#define ST25R39_ISO1443B_FELICA_NO_SOF			BIT(5)
#define ST25R39_ISO1443B_FELICA_NO_EOF			BIT(4)
#define ST25R39_ISO1443B_FELICA_EOF_12			BIT(3)
#define ST25R39_ISO1443B_FELICA_PHC_TH			BIT(2)
#define ST25R39_ISO1443B_FELICA_F_P_MASK		GENMASK(1, 0)

#define ST25R39_STREAM_MODE			0x08
/* not used						BIT(7) */
#define ST25R39_STREAM_MODE_SCF_MASK			GENMASK(6, 5)
#define ST25R39_STREAM_MODE_SCF_OFFSET			5
#define ST25R39_STREAM_MODE_SCF_BPSK_FC4		0x2
#define ST25R39_STREAM_MODE_SCF_BPSK_FC8		0x1
#define ST25R39_STREAM_MODE_SCF_BPSK_FC16		0x0
#define ST25R39_STREAM_MODE_SCF_SC_FC8			0x3
#define ST25R39_STREAM_MODE_SCF_SC_FC16			0x2
#define ST25R39_STREAM_MODE_SCF_SC_FC32			0x1
#define ST25R39_STREAM_MODE_SCF_SC_FC64			0x0
#define ST25R39_STREAM_MODE_SCF_GET(freq) \
	(((freq) & ST25R39_STREAM_MODE_SCF_MASK) >> ST25R39_STREAM_MODE_SCF_OFFSET)
#define ST25R39_STREAM_MODE_SCF_SET(freq) \
	(((freq) << ST25R39_STEAM_MODE_SCF_OFFSET) & ST25R39_STREAM_MODE_SCF_MASK)
#define ST25R39_STREAM_MODE_SCP_MASK			GENMASK(4, 3)
#define ST25R39_STREAM_MODE_SCP_OFFSET			3
#define ST25R39_STREAM_MODE_SCP_SET(pulses) \
	(((((pulses) > 1) ? (pulses) / 2 : 0x0) << ST25R39_STREAM_MODE_SCP_OFF) & ST25R39_STREAM_MODE_SCP_MASK)
#define ST25R39_STREAM_MODE_SCP_GET(reg) \
	((((reg) & ST25R39_STREAM_MODE_SCP_MASK) >> ST25R39_STREAM_MODE_SCP_OFF) > 0 ? \
	 (((reg) & ST25R39_STREAM_MODE_SCP_MASK) >> ST25R39_STREAM_MODE_SCP_OFF) * 2 : 0x0)
#define ST25R39_STREAM_MODE_STX_MASK			GENMASK(2, 0)
/* not used						0x7 */
#define ST25R39_STREAM_MODE_STX_FC2			0x6
#define ST25R39_STREAM_MODE_STX_FC4			0x5
#define ST25R39_STREAM_MODE_STX_FC8			0x4
#define ST25R39_STREAM_MODE_STX_FC16			0x3
#define ST25R39_STREAM_MODE_STX_FC32			0x2
#define ST25R39_STREAM_MODE_STX_FC64			0x1
#define ST25R39_STREAM_MODE_STX_FC128			0x0
#define ST25R39_STREAM_MODE_STX_GET(reg) \
	((reg) & ST25R39_STREAM_MODE_STX_MASK)
#define ST25R39_STREAM_MODE_STX_SET(period) \
	((period) & ST25R39_STREAM_MODE_STX_MASK)

#define ST25R39_AUX_DEF				0x09
#define ST25R39_AUX_DEF_NO_CRC_RX			BIT(7)
#define ST25R39_AUX_DEF_CRC_2_FIFO			BIT(6)
#define ST25R39_AUX_DEF_TR_AM				BIT(5)
#define ST25R39_AUX_DEF_EN_FD				BIT(4)
#define ST25R39_AUX_DEF_OOK_HR				BIT(3)
#define ST25R39_AUX_DEF_RX_TOL				BIT(2)
#define ST25R39_AUX_DEF_NFC_N_MASK			GENMASK(1, 0)
#define ST25R39_AUX_DEF_NFC_N_GET(reg) \
	((reg) & ST25R39_AUX_DEF_NFC_N_MASK)
#define ST25R39_AUX_DEF_NFC_N_SET(cmd) \
	((cmd) & ST25R39_AUX_DEF_NFC_N_MASK)

#define ST25R39_RECV_CONF1			0x0a
#define ST25R39_RECV_CONF1_CH_SEL			BIT(7)
#define ST25R39_RECV_CONF1_AMD_SEL			BIT(6)
#define ST25R39_RECV_CONF1_LP_MASK			GENMASK(5, 3)
#define ST25R39_RECV_CONF1_LP_OFFSET			3
#define ST25R39_RECV_CONF1_LP_7000kHz			0b101
#define ST25R39_RECV_CONF1_LP_2000kHz			0b100
#define ST25R39_RECV_CONF1_LP_300kHz			0b010
#define ST25R39_RECV_CONF1_LP_600kHz			0b001
#define ST25R39_RECV_CONF1_LP_1200kHz			0b000
#define ST25R39_RECV_CONF1_LP_GET(reg) \
	(((reg) & ST25R39_RECV_CONF1_LP_MASK) >> ST25R39_RECV_CONF1_LP_OFFSET)
#define ST25R39_RECV_CONF1_LP_SET(ctrl) \
	(((ctrl) << ST25R39_RECV_CONF1_LP_OFFSET) & ST25R39_RECV_CONF1_LP_MASK)
#define ST25R39_RECV_CONF1_ZERO_MASK			GENMASK(2, 0)
#define ST25R39_RECV_CONF1_ZERO_OFFSET			3
#define ST25R39_RECV_CONF1_ZERO_F60_T400		0b000
#define ST25R39_RECV_CONF1_ZERO_F60_T200		0b100
#define ST25R39_RECV_CONF1_ZERO_F40_T80			0b010
#define ST25R39_RECV_CONF1_ZERO_F12_T400		0b001
#define ST25R39_RECV_CONF1_ZERO_F12_T80			0b011
#define ST25R39_RECV_CONF1_ZERO_F12_T200		0b101
#define ST25R39_RECV_CONF1_ZERO_GET(reg) \
	((reg) & ST25R39_RECV_CONF1_ZERO_MASK)
#define ST25R39_RECV_CONF1_ZERO_SET(val) \
	((val) & ST25R39_RECV_CONF1_ZERO_MASK)

#define ST25R39_RECV_CONF2			0x0b
#define ST25R39_RECV_CONF2_RX_LP			BIT(7)
#define ST25R39_RECV_CONF2_LF_OP			BIT(6)
#define ST25R39_RECV_CONF2_LF_EN			BIT(5)
#define ST25R39_RECV_CONF2_AGC_EN			BIT(4)
#define ST25R39_RECV_CONF2_AGC_M			BIT(3)
#define ST25R39_RECV_CONF2_AGC_ALG			BIT(2)
#define ST25R39_RECV_CONF2_SQM_DYN			BIT(1)
#define ST25R39_RECV_CONF2_PMIX_CL			BIT(0)

#define ST25R39_RECV_CONF3			0x0c
#define ST25R39_RECV_CONF3_RG1_AM_MASK			GENMASK(7, 5)
#define ST25R39_RECV_CONF3_RG1_AM_OFFSET		5
#define ST25R39_RECV_CONF3_RG1_GAIN2VAL(gain) \
	((gain) < 0 ? 0x7 : (gain) / 2.5)
#define ST25R39_RECV_CONF3_RG1_VAL2GAIN(val) \
	((val) < 0 ? 5.5 : (val) * 2.5)
#define ST25R39_RECV_CONF3_RG1_AM_GET(reg) \
	(((reg) & ST25R39_RECV_CONF3_RG1_AM_MASK) >> ST25R39_RECV_CONF3_RG1_AM_OFFSET)
#define ST25R39_RECV_CONF3_RG1_AM_SET(val) \
	(((val) << ST25R39_RECV_CONF3_RG1_AM_OFFSET) & ST25R39_RECV_CONF3_RG1_AM_MASK)
#define ST25R39_RECV_CONF3_RG1_PM_MASK			GENMASK(4, 2)
#define ST25R39_RECV_CONF3_RG1_PM_OFFSET		2
#define ST25R39_RECV_CONF3_RG1_PM_GET(reg) \
	(((reg) & ST25R39_RECV_CONF3_RG1_PM_MASK) >> ST25R39_RECV_CONF3_RG1_PM_OFFSET)
#define ST25R39_RECV_CONF3_RG1_PM_SET(val) \
	(((val) << ST25R39_RECV_CONF3_RG1_PM_OFFSET) & ST25R39_RECV_CONF3_RG1_PM_MASK)

#define ST25R39_RECV_CONF4			0x0d
#define ST25R39_RECV_CONF4_RG2_AM_MASK			GENMASK(7, 4)
#define ST25R39_RECV_CONF4_RG2_AM_OFFSET		4
#define ST25R39_RECV_CONF4_RG2_AM_GET(reg) \
	(((reg) & ST25R39_RECV_CONF4_RG2_AM_MASK) >> ST25R39_RECV_CONF4_RG2_AM_OFFSET)
#define ST25R39_RECV_CONF4_RG2_AM_SET(reg) \
	(((reg) << ST25R39_RECV_CONF4_RG2_AM_OFFSET) & ST25R39_RECV_CONF4_RG2_AM_MASK)
#define ST25R39_RECV_CONF4_RG2_PM_MASK			GENMASK(3, 0)
#define ST25R39_RECV_CONF4_RG2_PM_OFFSET		0
#define ST25R39_RECV_CONF4_RG2_PM_GET(reg) \
	((reg) & ST25R39_RECV_CONF4_RG2_PM_MASK)
#define ST25R39_RECV_CONF4_RG2_PM_SET(gain) \
	((reg) & ST25R39_RECV_CONF4_RG2_PM_MASK)

#define ST25R39_MASK_RECV_TIMER			0x0e
#define ST25R39_MASK_RECV_TIMER_MRT_MASK		GENMASK(7, 0)
#define ST25R39_MASK_RECV_TIMER_MRT_OFFSET		0
#define ST25R39_MASK_RECV_TIMER_MRT(timeout) \
	(((timeout) * 18 /* TODO bogus */) & ST25R39_MASK_RECV_TIMER_MRT_MASK)

#define ST25R39_NO_RESP_TIMER1			0x0f
#define ST25R39_NO_RESP_TIMER1_MASK			GENMASK(7, 0)
#define ST25R39_NO_RESP_TIMER2_OFFSET			0

#define ST25R39_NO_RESP_TIMER2			0x10
#define ST25R39_NO_RESP_TIMER2_MASK			GENMASK(7, 0)
#define ST25R39_NO_RESP_TIMER2_OFFSET			0

#define ST25R39_NO_RESP_TIMER_GET(reg1, reg2) \
	(((uint16_t)(reg1) << 8) | (reg2))

#define ST25R39_NO_RESP_TIMER_SET_HI(val) \
	(((val) >> 8) & ST25R39_NO_RESP_TIMER1_MASK)
#define ST25R39_NO_RESP_TIMER_SET_LO(val) \
	((val) & ST25R39_NO_RESP_TIMER2_MASK)

#define ST25R39_GP_NO_RESP_TIMER		0x11
#define ST25R39_GP_NO_RESP_TIMER_GPTC_MASK		GENMASK(7, 5)
#define ST25R39_GP_NO_RESP_TIMER_GPTC_OFFSET		5
/* not used						0x4 - 0x7 */
#define ST25R39_TIMER_TRIGGER_SOURCE_TX_END		0x3
#define ST25R39_TIMER_TRIGGER_SOURCE_RX_START		0x2
#define ST25R39_TIMER_TRIGGER_SOURCE_RX_END		0x1
#define ST25R39_TIMER_TRIGGER_SOURCE_NONE		0x0
#define ST25R39_GP_NO_RESP_TIMER_GPTC_GET(reg) \
	(((reg) & ST25R39_GP_NO_RESP_TIMER_GPTC_MASK) >> ST25R39_GP_NO_RESP_TIMER_GPTC_OFFSET)
#define ST25R39_GP_NO_RESP_TIMER_GPTC_SET(src) \
	(((src) << ST25R39_GP_NO_RESP_TIMER_GPTC_OFFSET) & ST25R39_GP_NO_RESP_TIMER_GPTC_MASK)
/* not used						BIT(4) */
/* not used						BIT(3) */
/* not used						BIT(2) */
#define ST25R39_GP_NO_RESP_TIMER_NRT_EMV		BIT(1)
#define ST25R39_GP_NO_RESP_TIMER_NRT_STEP		BIT(0)

#define ST25R39_GP_TIMER1			0x12
#define ST25R39_GP_TIMER1_MASK				GENMASK(7, 0)
#define ST25R39_GP_TIMER2_OFFSET			0

#define ST25R39_GP_TIMER2			0x13
#define ST25R39_GP_TIMER2_MASK				GENMASK(7, 0)
#define ST25R39_GP_TIMER2_OFFSET			0

#define ST25R39_GP_TIMER_GET(reg1, reg2) \
	(((uint16_t)(reg1) << 8) | (reg2))

#define ST25R39_GP_TIMER_SET_HI(val) \
	(((val) >> 8) & ST25R39_NO_RESP_TIMER1_MASK)
#define ST25R39_GP_TIMER_SET_LO(val) \
	((val) & ST25R39_NO_RESP_TIMER2_MASK)

#define ST25R39_MASK_MAIN_IRQ			0x14
#define ST25R39_MASK_MAIN_IRQ_OSC			BIT(7)
#define ST25R39_MASK_MAIN_IRQ_WL			BIT(6)
#define ST25R39_MASK_MAIN_IRQ_RXS			BIT(5)
#define ST25R39_MASK_MAIN_IRQ_RXE			BIT(4)
#define ST25R39_MASK_MAIN_IRQ_TXE			BIT(3)
#define ST25R39_MASK_MAIN_IRQ_COL			BIT(2)
/* not used						BIT(1) */
/* not used						BIT(0) */
#define ST25R39_MASK_MAIN_IRQ_ALL \
	ST25R39_MASK_MAIN_IRQ_OSC | ST25R39_MASK_MAIN_IRQ_WL | \
	ST25R39_MASK_MAIN_IRQ_RXS | ST25R39_MASK_MAIN_IRQ_RXE | \
	ST25R39_MASK_MAIN_IRQ_TXE | ST25R39_MASK_MAIN_IRQ_COL

#define ST25R39_MASK_TIMER_NFC_IRQ		0x15
#define ST25R39_MASK_TIMER_NFC_IRQ_DCT			BIT(7)
#define ST25R39_MASK_TIMER_NFC_IRQ_NRE			BIT(6)
#define ST25R39_MASK_TIMER_NFC_IRQ_GPE			BIT(5)
#define ST25R39_MASK_TIMER_NFC_IRQ_EON			BIT(4)
#define ST25R39_MASK_TIMER_NFC_IRQ_EOF			BIT(3)
#define ST25R39_MASK_TIMER_NFC_IRQ_CAC			BIT(2)
#define ST25R39_MASK_TIMER_NFC_IRQ_CAT			BIT(1)
#define ST25R39_MASK_TIMER_NFC_IRQ_NFCT			BIT(0)
#define ST25R39_MASK_TIMER_NFC_IRQ_ALL \
	ST25R39_MASK_TIMER_NFC_IRQ_DCT | ST25R39_MASK_TIMER_NFC_IRQ_NRE | \
	ST25R39_MASK_TIMER_NFC_IRQ_GPE | ST25R39_MASK_TIMER_NFC_IRQ_EON | \
	ST25R39_MASK_TIMER_NFC_IRQ_EOF | ST25R39_MASK_TIMER_NFC_IRQ_CAC | \
	ST25R39_MASK_TIMER_NFC_IRQ_CAT | ST25R39_MASK_TIMER_NFC_IRQ_NFCT

#define ST25R39_MASK_ERROR_WAKEUP_IRQ		0x16
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_CRC		BIT(7)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_PAR		BIT(6)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_ERR2		BIT(5)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_ERR1		BIT(4)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_WT		BIT(3)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_WAM		BIT(2)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_WPH		BIT(1)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_WCAP		BIT(0)
#define ST25R39_MASK_ERROR_WAKEUP_IRQ_ALL \
	ST25R39_MASK_ERROR_WAKEUP_IRQ_CRC | ST25R39_MASK_ERROR_WAKEUP_IRQ_PAR | \
	ST25R39_MASK_ERROR_WAKEUP_IRQ_ERR2 | ST25R39_MASK_ERROR_WAKEUP_IRQ_ERR1 | \
	ST25R39_MASK_ERROR_WAKEUP_IRQ_WT | ST25R39_MASK_ERROR_WAKEUP_IRQ_WAM | \
	ST25R39_MASK_ERROR_WAKEUP_IRQ_WPH | ST25R39_MASK_ERROR_WAKEUP_IRQ_WCAP

#define ST25R39_MAIN_IRQ			0x17
#define ST25R39_MAIN_IRQ_OSC				BIT(7)
#define ST25R39_MAIN_IRQ_WL				BIT(6)
#define ST25R39_MAIN_IRQ_RXS				BIT(5)
#define ST25R39_MAIN_IRQ_RXE				BIT(4)
#define ST25R39_MAIN_IRQ_TXE				BIT(3)
#define ST25R39_MAIN_IRQ_COL				BIT(2)
#define ST25R39_MAIN_IRQ_TIM				BIT(1)
#define ST25R39_MAIN_IRQ_ERR				BIT(0)
#define ST25R39_MAIN_IRQ_ALL \
	ST25R39_MAIN_IRQ_OSC | ST25R39_MAIN_IRQ_WL | \
	ST25R39_MAIN_IRQ_RXS | ST25R39_MAIN_IRQ_RXE | \
	ST25R39_MAIN_IRQ_TXE | ST25R39_MAIN_IRQ_COL | \
	ST25R39_MAIN_IRQ_TIM | ST25R39_MAIN_IRQ_ERR

#define ST25R39_TIMER_NFC_IRQ			0x18
#define ST25R39_TIMER_NFC_IRQ_DCT			BIT(7)
#define ST25R39_TIMER_NFC_IRQ_NRE			BIT(6)
#define ST25R39_TIMER_NFC_IRQ_GPE			BIT(5)
#define ST25R39_TIMER_NFC_IRQ_EON			BIT(4)
#define ST25R39_TIMER_NFC_IRQ_EOF			BIT(3)
#define ST25R39_TIMER_NFC_IRQ_CAC			BIT(2)
#define ST25R39_TIMER_NFC_IRQ_CAT			BIT(1)
#define ST25R39_TIMER_NFC_IRQ_NFCT			BIT(0)
#define ST25R39_TIMER_NFC_IRQ_ALL \
	ST25R39_TIMER_NFC_IRQ_DCT | ST25R39_TIMER_NFC_IRQ_NRE | \
	ST25R39_TIMER_NFC_IRQ_GPE | ST25R39_TIMER_NFC_IRQ_EON | \
	ST25R39_TIMER_NFC_IRQ_EOF | ST25R39_TIMER_NFC_IRQ_CAC | \
	ST25R39_TIMER_NFC_IRQ_CAT | ST25R39_TIMER_NFC_IRQ_NFCT

#define ST25R39_ERROR_WAKEUP_IRQ		0x19
#define ST25R39_ERROR_WAKEUP_IRQ_CRC			BIT(7)
#define ST25R39_ERROR_WAKEUP_IRQ_PAR			BIT(6)
#define ST25R39_ERROR_WAKEUP_IRQ_ERR2			BIT(5)
#define ST25R39_ERROR_WAKEUP_IRQ_ERR1			BIT(4)
#define ST25R39_ERROR_WAKEUP_IRQ_WT			BIT(3)
#define ST25R39_ERROR_WAKEUP_IRQ_WAM			BIT(2)
#define ST25R39_ERROR_WAKEUP_IRQ_WPH			BIT(1)
#define ST25R39_ERROR_WAKEUP_IRQ_WCAP			BIT(0)
#define ST25R39_ERROR_WAKEUP_IRQ_ALL \
	ST25R39_ERROR_WAKEUP_IRQ_CRC | ST25R39_ERROR_WAKEUP_IRQ_PAR | \
	ST25R39_ERROR_WAKEUP_IRQ_ERR2 | ST25R39_ERROR_WAKEUP_IRQ_ERR1 | \
	ST25R39_ERROR_WAKEUP_IRQ_WT | ST25R39_ERROR_WAKEUP_IRQ_WAM | \
	ST25R39_ERROR_WAKEUP_IRQ_WPH | ST25R39_ERROR_WAKEUP_IRQ_WCAP

#define ST25R39_FIFO_STATUS1			0x1a
/* not used						BIT(7) */
#define ST25R39_FIFO_STATUS1_FIFO_B_MASK		GENMASK(6, 0)
#define ST25R39_FIFO_STATUS1_FIFO_B_OFFSET		0

#define ST25R39_FIFO_STATUS2			0x1b
/* not used						BIT(7) */
#define ST25R39_FIFO_STATUS2_FIFO_UNF			BIT(6)
#define ST25R39_FIFO_STATUS2_FIFO_OVR			BIT(5)
#define ST25R39_FIFO_STATUS2_FIFO_NCP			BIT(4)
#define ST25R39_FIFO_STATUS2_FIFO_LB_MASK		GENMASK(3, 1)
#define ST25R39_FIFO_STATUS2_FIFO_LB_OFFSET		1
#define ST25R39_FIFO_STATUS2_FIFO_LB_GET(reg) \
	(((reg) & ST25R39_FIFO_STATUS2_FIFO_LB_MASK) >> ST25R39_FIFO_STATUS2_FIFO_LB_OFFSET)
#define ST25R39_FIFO_STATUS2_FIFO_LB_SET(reg) \
	(((reg) << ST25R39_FIFO_STATUS2_FIFO_LB_OFFSET) & ST25R39_FIFO_STATUS2_FIFO_LB_MASK)
#define ST25R39_FIFO_STATUS2_NP_LB			BIT(0)

#define ST25R39_COLLISION_DISP			0x1c
#define ST25R39_COLLISION_DISP_C_BYTE_MASK		GENMASK(7, 4)
#define ST25R39_COLLISION_DISP_C_BYTE_OFFSET		4
#define ST25R39_COLLISION_DISP_C_BYTE_GET(reg) \
	(((reg) ST25R39_COLLISION_DISP_C_BYTE_MASK) >> ST25R39_COLLISION_DISP_C_BYTE_OFFSET)
#define ST25R39_COLLISION_DISP_C_BIT_MASK		GENMASK(3, 1)
#define ST25R39_COLLISION_DISP_C_BIT_OFFSET		1
#define ST25R39_COLLISION_DISP_C_BIT_GET(reg) \
	(((reg) & ST25R39_COLLISION_DISP_C_BIT_MASK) >> ST25R39_COLLISION_DISP_C_BIT_OFFSET)
#define ST25R39_COLLISION_DISP_C_PB			BIT(0)

#define ST25R39_NUM_TX_BYTES1			0x1d
#define ST25R39_NUM_TX_BYTES1_NTX_MASK			GENMASK(7, 0)
#define ST25R39_NUM_TX_BYTES1_NTX_OFFSET		0
#define ST25R39_NUM_TX_BYTES1_NTX_GET(reg) \
	((reg) & ST25R39_NUM_TX_BYTES1_NTX_MASK)
#define ST25R39_NUM_TX_BYTES1_NTX_SET(bytes) \
	((bytes) & ST25R39_NUM_TX_BYTES1_NTX_MASK)

#define ST25R39_NUM_TX_BYTES2			0x1e
#define ST25R39_NUM_TX_BYTES2_NTX_MASK			GENMASK(7, 3)
#define ST25R39_NUM_TX_BYTES2_NTX_OFFSET		3
#define ST25R39_NUM_TX_BYTES2_NTX_GET(reg) \
	(((reg) & ST25R39_NUM_TX_BYTES2_NTX_MASK) >> ST25R39_NUM_TX_BYTES2_NTX_OFFSET)
#define ST25R39_NUM_TX_BYTES2_NTX_SET(bytes) \
	(((bytes) << ST25R39_NUM_TX_BYTES2_NTX_OFFSET) & ST25R39_NUM_TX_BYTES2_NTX_MASK)
#define ST25R39_NUM_TX_BYTES2_NBTX_MASK			GENMASK(2, 0)
#define ST25R39_NUM_TX_BYTES2_NBTX_OFFSET		0
#define ST25R39_NUM_TX_BYTES2_NBTX_GET(reg) \
	((reg) & ST25R39_NUM_TX_BYTES2_NBTX_MASK)
#define ST25R39_NUM_TX_BYTES2_NBTX_SET(reg) \
	((reg) & ST25R39_NUM_TX_BYTES2_NBTX_MASK)

#define ST25R39_NUM_TX_BYTES_GET(reg1, reg2) \
	(((uint16_t)ST25R39_NUM_TX_BYTES1_NTX_GET(reg1) << 5) | \
	 ST25R39_NUM_TX_BYTES2_NTX_GET(reg2))

#define ST25R39_NUM_TX_BYTES_NTX_SET_HI(val) \
	(((val) >> 8) & ST25R39_NUM_TX_BYTES1_NTX_MASK)

#define ST25R39_NUM_TX_BYTES_NTX_SET_LO(val) \
	(((val) << ST25R39_NUM_TX_BYTES2_NTX_OFFSET) & ST25R39_NUM_TX_BYTES2_NTX_MASK)

#define ST25R39_NFCIP_BIT_RATE_DISP		0x1f
#define ST25R39_NFCIP_BIT_RATE_DISP_NFC_RATE_MASK	GENMASK(7, 4)
#define ST25R39_NFCIP_BIT_RATE_DISP_NFC_RATE_OFFSET	4
#define ST25R39_NFCIP_BIT_RATE_DISP_NFC_RATE_GET(reg) \
	(((reg) & ST25R39_NFCIP_BIT_RATE_DISP_NFC_RATE_MASK) >> ST25R39_NFCIP_BIT_RATE_DISP_NFC_RATE_OFFSET)

#define ST25R39_AD_CONV_OUT			0x20
#define ST25R39_AD_CONV_OUT_mV(reg) \
	(((uint16_t)(reg) * 23) + \
	 ((((uint16_t)(reg) * 438 + 500)) / 1000))

#define ST25R39_ANT_CAL_CTL			0x21
#define ST25R39_ANT_CAL_CTL_TRIM_S			BIT(7)
#define ST25R39_ANT_CAL_CTL_TRE_MASK			GENMASK(6, 3)
#define ST25R39_ANT_CAL_CTL_TRE_OFFSET			3
#define ST25R39_ANT_CAL_CTL_TRE_GET(reg) \
	(((reg) & ST25R39_ANT_CAL_CTL_TRE_MASK) >> ST25R39_ANT_CAL_CTL_TRE_OFFSET)
#define ST25R39_ANT_CAL_CTL_TRE_SET(trim) \
	(((reg) << ST25R39_ANT_CAL_CTL_TRE_OFFSET) & ST25R39_ANT_CAL_CTL_TRE_MASK)
/* not used						BIT(2) */
/* not used						BIT(1) */
/* not used						BIT(0) */

#define ST25R39_ANT_CAL_TARGET_CTL		0x22
#define ST25R39_ANT_CAL_TARGET_CTL_MASK			GENMASK(7, 0)
#define ST25R39_ANT_CAL_TARGET_CTL_OFFSET		0
#define ST25R39_ANT_CAL_TARGET_CTL_ACT_GET(reg) \
	(((uint16_t)(reg) * 90) / 128)
#define ST25R39_ANT_CAL_TARGET_CTL_ACT_SET(angle) \
	(((uint16_t)(angle) * 128) / 90)

#define ST25R39_ANT_CAL_DISPLAY			0x23
#define ST25R39_ANT_CAL_DISPLAY_TRI_MASK		GENMASK(7, 4)
#define ST25R39_ANT_CAL_DISPLAY_TRI_OFFSET		4
#define ST25R39_ANT_CAL_DISPLAY_TRI_GET(reg) \
	(((reg) & ST25R39_ANT_CAL_DISPLAY_TRI_MASK) >> ST25R39_ANT_CAL_DISPLAY_TRI_OFFSET)
#define ST25R39_ANT_CAL_DISPLAY_TRI_ERR			BIT(3)
/* not used						BIT(2) */
/* not used						BIT(1) */
/* not used						BIT(0) */

#define ST25R39_AM_MOD_DEPTH_CTL		0x24
#define ST25R39_AM_MOD_DEPTH_CTL_AM_S			BIT(7)
#define ST25R39_AM_MOD_DEPTH_CTL_MOD_MASK		GENMASK(6, 1)
#define ST25R39_AM_MOD_DEPTH_CTL_MOD_OFFSET		1
#define ST25R39_AM_MOD_DEPTH_CTL_MOD_GET(reg) \
	(((reg) & ST25R39_AM_MOD_DEPTH_CTL_MOD_MASK) >> ST25R39_AM_MOD_DEPTH_CTL_MOD_OFFSET)
#define ST25R39_AM_MOD_DEPTH_CTL_MODE_SET(depth) \
	(((depth) << ST25R39_AM_MOD_DEPTH_CTL_MOD_OFFSET) & ST25R39_AM_MOD_DEPTH_CTL_MOD_MASK)
/* not used						BIT(0) */

#define ST25R39_AM_MOD_DEPTH_DISPLAY		0x25
#define ST25R39_AM_MOD_DEPTH_DISPLAY_MD_MASK		GENMASK(7, 0)
#define ST25R39_AM_MOD_DEPTH_DISPLAY_MD_OFFSET		0
#define ST25R39_AM_MOD_DEPTH_DISPLAY_MD_ERROR		0xff

#define ST25R39_RFO_AM_MOD_LEVEL_DEF		0x26
#define ST25R39_RFO_AM_MOD_LEVEL_DEF_DRAM_GET(reg) \
	((reg) * 2)
#define ST25R39_RFO_AM_MOD_LEVEL_DEF_DRAM_SET(res) \
	((res) / 2)

#define ST25R39_RFO_NORM_MOD_LEVEL_DEF		0x27
#define ST25R39_RFO_NORM_MOD_LEVEL_DEF_DROF_MASK	GENMASK(7, 0)
#define ST25R39_RFO_NORM_MOD_LEVEL_DEF_DROF_OFFSET	0
#define ST25R39_RFO_NORM_MOD_LEVEL_DEF_DROF_GET(reg) \
	(((reg) & ST25R39_RFO_NORM_MOD_LEVEL_DEF_DROF_MASK) * 2)
#define ST25R39_RFO_NORM_MOD_LEVEL_DEF_DROF_SET(res) \
	(((res) & ST25R39_RFO_NORM_MOD_LEVEL_DEF_DROF_MASK) / 2)

/* not used					0x28 */

#define ST25R39_EXT_FIELD_DET_THRES		0x29
/* not used						BIT(7) */
#define ST25R39_EXT_FIELD_DET_THRES_25mV		0x08
#define ST25R39_EXT_FIELD_DET_THRES_33mV		0x09
#define ST25R39_EXT_FIELD_DET_THRES_47mV		0x0a
#define ST25R39_EXT_FIELD_DET_THRES_64mV		0x0b
#define ST25R39_EXT_FIELD_DET_THRES_75mV		0x00
#define ST25R39_EXT_FIELD_DET_THRES_90mV		0x0c
#define ST25R39_EXT_FIELD_DET_THRES_105mV		0x01
#define ST25R39_EXT_FIELD_DET_THRES_125mV		0x0d
#define ST25R39_EXT_FIELD_DET_THRES_150mV		0x02
#define ST25R39_EXT_FIELD_DET_THRES_175mV		0x0e
#define ST25R39_EXT_FIELD_DET_THRES_205mV		0x03
#define ST25R39_EXT_FIELD_DET_THRES_250mV		0x0f
#define ST25R39_EXT_FIELD_DET_THRES_290mV		0x04
#define ST25R39_EXT_FIELD_DET_THRES_400mV		0x05
#define ST25R39_EXT_FIELD_DET_THRES_560mV		0x06
#define ST25R39_EXT_FIELD_DET_THRES_800mV		0x07
#define ST25R39_EXT_FIELD_DET_THRES_TRG_L_MASK		GENMASK(6, 4)
#define ST25R39_EXT_FIELD_DET_THRES_TRG_L_OFFSET	4
#define ST25R39_EXT_FIELD_DET_THRES_TRG_L_GET(reg) \
	(((reg) & ST25R39_EXT_FIELD_DET_THRES_TRG_L_MASK) >> ST25R39_EXT_FIELD_DET_THRES_TRG_L_OFFSET)
#define ST25R39_EXT_FIELD_DET_THRES_TRG_L_SET(thres) \
	(((thres) << ST25R39_EXT_FIELD_DET_THRES_TRG_L_OFFSET) & ST25R39_EXT_FIELD_DET_THRES_TRG_L_MASK)
#define ST25R39_EXT_FIELD_DET_THRES_RFE_T_MASK		GENMASK(3, 0)
#define ST25R39_EXT_FIELD_DET_THRES_RFE_T_OFFSET	0
#define ST25R39_EXT_FIELD_DET_THRES_RFE_T_GET(reg) \
	((reg) & ST25R39_EXT_FIELD_DET_THRES_RFE_T_MASK)
#define ST25R39_EXT_FIELD_DET_THRES_RFE_T_SET(reg) \
	((reg) & ST25R39_EXT_FIELD_DET_THRES_RFE_T_MASK)

#define ST25R39_REG_VOLT_CTL			0x2a
#define ST25R39_REG_VOLT_CTL_REG_S			BIT(7)
#define ST25R39_REG_VOLT_CTL_REGE_MASK			GENMASK(6, 3)
#define ST25R39_REG_VOLT_CTL_REGE_OFFSET		3
#define ST25R39_REG_VOLT_CTL_REGE_VAL_5V0(val) \
	(((uint16_t)(val) * 120) + 3300)
#define ST25R39_REG_VOLT_CTL_REGE_VAL_3V3(val) \
	(((uint16_t)(val) * 100) + 1900)
#define ST25R39_REG_VOLT_CTL_REGE_mV_5V0(mV) \
	(((uint16_t)(mV) - 3300) / 120)
#define ST25R39_REG_VOLT_CTL_REGE_mV_3V3(mV) \
	(((uint16_t)(mV) - 1900) / 100)
#define ST25R39_REG_VOLT_CTL_REGE_GET(reg) \
	(((reg) & ST25R39_REG_VOLT_CTL_REGE_MASK) >> ST25R39_REG_VOLT_CTL_REGE_OFFSET)
#define ST25R39_REG_VOLT_CTL_REGE_SET(volts) \
	(((volts) << ST25R39_REG_VOLT_CTL_REGE_OFFSET) & ST25R39_REG_VOLT_CTL_REGE_MASK)
#define ST25R39_REG_VOLT_CTL_MPSV_MASK			GENMASK(2, 1)
#define ST25R39_REG_VOLT_CTL_MPSV_OFFSET		1
#define ST25R39_REG_VOLT_CTL_MPSV_VSP_RF		0x03
#define ST25R39_REG_VOLT_CTL_MPSV_VSP_D			0x02
#define ST25R39_REG_VOLT_CTL_MPSV_VSP_A			0x01
#define ST25R39_REG_VOLT_CTL_MPSV_VDD			0x00
#define ST25R39_REG_VOLT_CTL_MSPV_GET(reg) \
	(((reg) & ST25R39_REG_VOLT_CTL_MPSV_MASK) >> ST25R39_REG_VOLT_CTL_MPSV_OFFSET)
#define ST25R39_REG_VOLT_CTL_MPSV_SET(src) \
	(((src) << ST25R39_REG_VOLT_CTL_MPSV_OFFSET) & ST25R39_REG_VOLT_CTL_MPSV_MASK)
/* not used						BIT(0) */

#define ST25R39_REG_TIMER_DISPLAY		0x2b
#define ST25R39_REG_TIMER_DISPLAY_REG_MASK		GENMASK(7, 4)
#define ST25R39_REG_TIMER_DISPLAY_REG_OFFSET		4
#define ST25R39_REG_TIMER_DISPLAY_REG_VAL_5V0(val) \
	(((uint16_t)(val) * 120) + 3300)
#define ST25R39_REG_TIMER_DISPLAY_REG_VAL_3V3(val) \
	(((uint16_t)(val) * 100) + 1900)
#define ST25R39_REG_TIMER_DISPLAY_REG_mV_5V0(mV) \
	(((uint16_t)(mV) - 3300) / 120)
#define ST25R39_REG_TIMER_DISPLAY_REG_mV_3V3(mV) \
	(((uint16_t)(mV) - 1900) / 100)
#define ST25R39_REG_TIMER_DISPLAY_REG_GET(reg) \
	(((reg) & ST25R39_REG_TIMER_DISPLAY_REG_MASK) >> ST25R39_REG_TIMER_DISPLAY_REG_OFFSET)
#define ST25R39_REG_TIMER_DISPLAY_REG_SET(mV) \
	(((mv) << ST25R39_REG_TIMER_DISPLAY_REG_OFFSET) & ST25R39_REG_TIMER_DISPLAY_REG_MASK)
/* not used						BIT(3) */
#define ST25R39_REG_TIMER_DISPLAY_GPT_ON		BIT(2)
#define ST25R39_REG_TIMER_DISPLAY_NRT_ON		BIT(1)
#define ST25R39_REG_TIMER_DISPLAY_MRT_ON		BIT(0)

/* rssi(x) = 14.2618915496391 ^ (0.322907032961944 * x) */
#define ST25R39_RSSI_DISP			0x2c
#define ST25R39_RSSI_DISP_RSSI_AM_MASK			GENMASK(7,4)
#define ST25R39_RSSI_DISP_RSSI_AM_OFFSET		4
#define ST25R39_RSSI_DISP_RSSI_AM_GET(reg) \
	(((reg) & ST25R39_RSSI_DISP_RSSI_AM_MASK) >> ST25R39_RSSI_DISP_RSSI_AM_OFFSET)
#define ST25R39_RSSI_DISP_RSSI_PM_MASK			GENMASK(3,0)
#define ST25R39_RSSI_DISP_RSSI_PM_OFFSET		0
#define ST25R39_RSSI_DISP_RSSI_PM_GET(reg) \
	((reg) & ST25R39_RSSI_DISP_RSSI_PM_MASK)

#define ST25R39_GAIN_REDUCTION_STATE		0x2d
#define ST25R39_GAIN_REDUCTION_STATE_GS_AM_MASK		GENMASK(7, 4)
#define ST25R39_GAIN_REDUCTION_STATE_GS_AM_OFFSET	4
#define ST25R39_GAIN_REDUCTION_STATE_GS_AM_GET(reg) \
	(((reg) & ST25R39_GAIN_REDUCTION_STATE_GS_AM_MASK) >> ST25R39_GAIN_REDUCTION_STATE_GS_AM_OFFSET)
#define ST25R39_GAIN_REDUCTION_STATE_GS_PM_MASK		GENMASK(3, 0)
#define ST25R39_GAIN_REDUCTION_STATE_GS_PM_OFFSET	0
#define ST25R39_GAIN_REDUCTION_STATE_GS_PM_GET(reg) \
	((reg) & ST25R39_GAIN_REDUCTION_STATE_GS_PM_MASK)

/* reserved					0x2e */
/* reserved					0x2f */

#define ST25R39_AUX_DISP			0x30
#define ST25R39_AUX_DISP_A_CHA				BIT(7)
#define ST25R39_AUX_DISP_EFD_O				BIT(6)
#define ST25R39_AUX_DISP_TX_ON				BIT(5)
#define ST25R39_AUX_DISP_OSC_OK				BIT(4)
#define ST25R39_AUX_DISP_RX_ON				BIT(3)
#define ST25R39_AUX_DISP_RX_ACT				BIT(2)
#define ST25R39_AUX_DISP_NFC_T				BIT(1)
#define ST25R39_AUX_DISP_EN_AC				BIT(0)

#define ST25R39_WAKEUP_TIMER_CTL		0x31
#define ST25R39_WAKEUP_TIMER_CTL_WUR			BIT(7)
#define ST25R39_WAKEUP_TIMER_CTL_WUT_MASK		GENMASK(6, 4)
#define ST25R39_WAKEUP_TIMER_CTL_WUT_OFFSET		4
#define ST25R39_WAKEUP_TIMER_CTL_WUT_GET(reg) \
	((((reg) & ST25R39_WAKEUP_TIMER_CTL_WUT_MASK) >> ST25R39_WAKEUP_TIMER_CTL_WUT_OFFSET) + 1)
#define ST25R39_WAKEUP_TIMER_CTL_WUT_SET(wake_factor) \
	((((wake_factor) - 1) << ST25R39_WAKEUP_TIMER_CTL_WUT_OFFSET) & ST25R39_WAKEUP_TIMER_CTL_WUT_MASK)
#define ST25R39_WAKEUP_TIMER_CTL_WTO			BIT(3)
#define ST25R39_WAKEUP_TIMER_CTL_WAM			BIT(2)
#define ST25R39_WAKEUP_TIMER_CTL_WPH			BIT(1)
/* reserved for future use				BIT(0) */

#define ST25R39_AMP_MEAS_CONF			0x32
#define ST25R39_AMP_MEAS_CONF_AM_D_MASK			GENMASK(7, 4)
#define ST25R39_AMP_MEAS_CONF_AM_D_OFFSET		4
#define ST25R39_AMP_MEAS_CONF_AM_D_GET(reg) \
	(((reg) & ST25R39_AMP_MEAS_CONF_AM_D_MASK) >> ST25R39_AMP_MEAS_CONF_AM_D_OFFSET)
#define ST25R39_AMP_MEAS_CONF_AM_D_SET(dam) \
	(((apm) << ST25R39_AMP_MEAS_CONF_AM_D_OFFSET) & ST25R39_AMP_MEAS_CONF_AM_D_MASK)
#define ST25R39_AMP_MEAS_CONF_AM_AAM			BIT(3)
#define ST25R39_AMP_MEAS_CONF_AM_AEW_MASK		GENMASK(2, 1)
#define ST25R39_AMP_MEAS_CONF_AM_AEW_OFFSET		1
/* weight(x) = 2 ^ (ln(2) * x) */
#define ST25R39_AMP_MEAS_CONF_AM_AEW_WEIGHT_32		0b11
#define ST25R39_AMP_MEAS_CONF_AM_AEW_WEIGHT_16		0b10
#define ST25R39_AMP_MEAS_CONF_AM_AEW_WEIGHT_8		0b01
#define ST25R39_AMP_MEAS_CONF_AM_AEW_WEIGHT_4		0b00
#define ST25R39_AMP_MEAS_CONF_AM_AEW_GET(reg) \
	(((reg) & ST25R39_AMP_MEAS_CONF_AM_AEW_MASK) >> ST25R39_AMP_MEAS_CONF_AM_AEW_OFFSET)
#define ST25R39_AMP_MEAS_CONF_AM_AEW_SET(val) \
	(((val) << ST25R39_AMP_MEAS_CONF_AM_AEW_OFFSET) & ST25R39_AMP_MEAS_CONF_AM_AEW_MASK)
#define ST25R39_AMP_MEAS_CONF_AM_AE			BIT(0)


#define ST25R39_AMP_MEAS_REF			0x33
#define ST25R39_AMP_MEAS_REF_AM_REF_MASK		GENMASK(7, 0)
#define ST25R39_AMP_MEAS_REF_AM_REF_GET(reg) \
	((reg) & ST25R39_AMP_MEAS_REF_AM_REF_MASK)
#define ST25R39_AMP_MEAS_REF_AM_REF_SET(ref) \
	((ref) & ST25R39_AMP_MEAS_REF_AM_REF_MASK)

#define ST25R39_AMP_MEAS_AUTO_AVG_DISP		0x34
#define ST25R39_AMP_MEAS_AUTO_AVG_AM_AAD_MASK		GENMASK(7, 0)
#define ST25R39_AMP_MEAS_AUTO_AVG_AM_AAD_GET(reg) \
	((reg) & ST25R39_AMP_MEAS_AUTO_AVG_AM_AAD_MASK)

#define ST25R39_AMP_MEAS_DISP			0x35
#define ST25R39_AMP_MEAS_DISP_AM_AMD_MASK		GENMASK(7, 0)
#define ST25R39_AMP_MEAS_DISP_AM_AMD_GET(reg) \
	((reg) & ST25R39_AMP_MEAS_DISP_AM_AMD_MASK)

#define ST25R39_PHASE_MEAS_CONF			0x36
#define ST25R39_PHASE_MEAS_CONF_PM_D_MASK		GENMASK(7, 4)
#define ST25R39_PHASE_MEAS_CONF_PM_D_OFFSET		4
#define ST25R39_PHASE_MEAS_CONF_PM_D_GET(reg) \
	(((reg) & ST25R39_PHASE_MEAS_CONF_PM_D_MASK) >> ST25R39_PHASE_MEAS_CONF_PM_D_OFFSET)
#define ST25R39_PHASE_MEAS_CONF_PM_D_SET(dpm) \
	(((dpm) << ST25R39_PHASE_MEAS_CONF_PM_D_OFFSET) & ST25R39_PHASE_MEAS_CONF_PM_D_MASK)
#define ST25R39_PHASE_MEAS_CONF_PM_AAM			BIT(3)
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_MASK		GENMASK(2, 1)
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_OFFSET		1
/* weight(x) = 2 ^ (ln(2) * x) */
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_WEIGHT_32	0b11
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_WEIGHT_16	0b10
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_WEIGHT_8		0b01
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_WEIGHT_4		0b00
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_GET(reg) \
	(((reg) & ST25R39_PHASE_MEAS_CONF_PM_AEW_MASK) >> ST25R39_PHASE_MEAS_CONF_PM_AEW_OFFSET)
#define ST25R39_PHASE_MEAS_CONF_PM_AEW_SET(val) \
	(((val) << ST25R39_PHASE_MEAS_CONF_PM_AEW_OFFSET) & ST25R39_PHASE_MEAS_CONF_PM_AEW_MASK)
#define ST25R39_PHASE_MEAS_CONF_PM_AE			BIT(0)

#define ST25R39_PHASE_MEAS_REF			0x37
#define ST25R39_PHASE_MEAS_REF_PM_REF_MASK		GENMASK(7, 0)
#define ST25R39_PHASE_MEAS_REF_PM_REF_GET(reg) \
	((reg) & ST25R39_PHASE_MEAS_REF_PM_REF_MASK)
#define ST25R39_PHASE_MEAS_REF_PM_REF_SET(ref) \
	((ref) & ST25R39_PHASE_MEAS_REF_PM_REF_MASK)

#define ST25R39_PHASE_MEAS_AUTO_AVG_DISP	0x38
#define ST25R39_PHASE_MEAS_AUTO_AVG_PM_AAD_MASK		GENMASK(7, 0)
#define ST25R39_PHASE_MEAS_AUTO_AVG_PM_AAD_GET(reg) \
	((reg) & ST25R39_PHASE_MEAS_AUTO_AVG_PM_AAD_MASK)

#define ST25R39_PHASE_MEAS_DISP			0x39
#define ST25R39_PHASE_MEAS_DISP_PM_AMD_MASK		GENMASK(7, 0)
#define ST25R39_PHASE_MEAS_DISP_PM_AMD_GET(reg) \
	((reg) & ST25R39_PHASE_MEAS_DISP_PM_AMD_MASK)

/* reserved					0x3a */
/* reserved					0x3b */
/* reserved					0x3c */
/* reserved					0x3d */
/* reserved					0x3e */

#define ST25R39_IC_IDENTITY			0x3f
#define ST25R39_IC_IDENTITY_TYPE_MASK			GENMASK(7, 3)
#define ST25R39_IC_IDENTITY_TYPE_OFFSET			3
#define ST25R39_IC_IDENTITY_REV_MASK			GENMASK(2, 0)

#define ST25R39_ANALOG_TEST_OBS			0x01
/* reserved						BIT(7) */
/* reserved						BIT(6) */
/* reserved						BIT(5) */
/* not used						BIT(4) */
#define ST25R39_ANALOG_TEST_OBS_TANA_MASK		GENMASK(3, 0)
#define ST25R39_ANALOG_TEST_OBS_TANA_OFFSET		0
#define ST25R39_ANALOG_TEST_OBS_TANA_DISABLE		0b0000
#define ST25R39_ANALOG_TEST_OBS_TANA_AM_AD_CHAN		0b0001
#define ST25R39_ANALOG_TEST_OBS_TANA_PM_AD_CHAN		0b0010
#define ST25R39_ANALOG_TEST_OBS_TANA_AM_PM_A_CHAN	0b0011
#define ST25R39_ANALOG_TEST_OBS_TANA_AM_PM_D_CHAN	0b0100
#define ST25R39_ANALOG_TEST_OBS_TANA_STAGE_1_2		0b0101
#define ST25R39_ANALOG_TEST_OBS_TANA_COL_AVOID_DETECT	0b1001
#define ST25R39_ANALOG_TEST_OBS_TANA_A_CHAN_SEL		0b1010
#define ST25R39_ANALOG_TEST_OBS_TANA_GET(reg) \
	((reg) & ST25R39_ANALOG_TEST_OBS_TANA_MASK)
#define ST25R39_ANALOG_TEST_OBS_TANA_SET(sel) \
	(((sel) & ST25R39_ANALOG_TEST_OBS_TANA_MASK))

#define ST25R39_DIRECT_CMD_SET_DEFAULT			0xc1
#define ST25R39_DIRECT_CMD_CLEAR			0xc2
/* #define ST25R39_DIRECT_CMD_CLEAR			0xc3 */
#define ST25R39_DIRECT_CMD_XMIT_WITH_CRC	0xc4
#define ST25R39_DIRECT_CMD_XMIT_WITHOUT_CRC	0xc5
#define ST25R39_DIRECT_CMD_XMIT_REQA		0xc6
#define ST25R39_DIRECT_CMD_XMIT_WUPA		0xc7
#define ST25R39_DIRECT_CMD_NFC_INIT_FIELD_ON		0xc8
#define ST25R39_DIRECT_CMD_NFC_RESP_FIELD_ON		0xc9
#define ST25R39_DIRECT_CMD_NFC_RESP_FIELD_ON_N0		0xca
#define ST25R39_DIRECT_CMD_NORMAL_NFC_MODE		0xcb
#define ST25R39_DIRECT_CMD_ANALOG_PRESET		0xcc
/* not used						0xcd - 0xcf */
#define ST25R39_DIRECT_CMD_MASK_RX_DATA			0xd0
#define ST25R39_DIRECT_CMD_UNMASK_RX_DATA		0xd1
#define ST25R39_DIRECT_CMD_MEASURE_AMPLITUDE		0xd3
#define ST25R39_DIRECT_CMD_SQUELCH			0xd4
#define ST25R39_DIRECT_CMD_RESET_RX_GAIN		0xd5
#define ST25R39_DIRECT_CMD_ADJUST_REGULATORS		0xd6
#define ST25R39_DIRECT_CMD_CAL_MOD_DEPTH		0xd7
#define ST25R39_DIRECT_CMD_CAL_ANT			0xd8
#define ST25R39_DIRECT_CMD_MEASURE_PHASE		0xd9
#define ST25R39_DIRECT_CMD_CLEAR_RSSI			0xda
/* not used						0xdb */
#define ST25R39_DIRECT_CMD_TRANSPARENT_MODE		0xdc
/* not used						0xdd */
#define ST25R39_DIRECT_CMD_MEASURE_PSU			0xdf
#define ST25R39_DIRECT_CMD_START_GP_TIMER		0xe0
#define ST25R39_DIRECT_CMD_START_WAKEUP_TIMER		0xe1
#define ST25R39_DIRECT_CMD_START_MASK_RX_TIMER		0xe2
#define ST25R39_DIRECT_CMD_START_NO_RESP_TIMER		0xe3
/* not used						0xe4 - 0xef */
/* reserved for test					0xf0 - 0xf9 */
#define ST25R39_DIRECT_CMD_CLEAR_TEST_REG		0xfa
/* reserved for test					0xfb */
#define ST25R39_DIRECT_CMD_TEST_ACCESS			0xfc
/* reserved for test					0xfd - 0xff */

#define ST25R39_IC_IDENTITY_TYPE(reg) \
	(((reg) & ST25R39_IC_IDENTITY_TYPE_MASK) >> ST25R39_IC_IDENTITY_TYPE_OFFSET)
#define ST25R39_IC_IDENTITY_REV(reg) \
	((reg) & ST25R39_IC_IDENTITY_REV_MASK)

#endif /* __ST25R39XX_REG_H_ */
